package v6.name.panitz.wip;

import java.util.HashMap;
import java.util.Map;

import v6.name.panitz.wip.Tree.ConDef;
import v6.name.panitz.wip.Tree.FieldSelect;
import v6.name.panitz.wip.Tree.FunCall;
import v6.name.panitz.wip.Tree.FunDef;
import v6.name.panitz.wip.Tree.IntLiteral;
import v6.name.panitz.wip.Tree.OpExpr;
import v6.name.panitz.wip.Tree.Param;
import v6.name.panitz.wip.Tree.Program;
import v6.name.panitz.wip.Tree.Variable;

public class Eval implements Visitor<Integer> {
	Map<String, Tree.FunDef> funs;
	Map<String, Integer> vars;

	@Override
	public Integer visit(IntLiteral il) {
		return il.n;
	}

	@Override
	public Integer visit(OpExpr oe) {
		switch (oe.op) {
		case mult:
			return oe.lhs.welcome(this)*oe.rhs.welcome(this);
		default:
			return oe.lhs.welcome(this)+oe.rhs.welcome(this);
		}
	}

	
	@Override
	public Integer visit(FunDef funDef) {
		return null;
	}

	@Override
	public Integer visit(Program program) {
		funs = new HashMap<>();
		program.funs.forEach(fun->funs.put(fun.name, fun));
		return program.main.welcome(this);
	}

	@Override
	public Integer visit(Variable variable) {
		return vars.get(variable.name);
	}

	@Override
	public Integer visit(FunCall funCall) {
		var newvars = new HashMap<String, Integer>();
		var fun = funs.get(funCall.name);
		var it = funCall.params.iterator();
		fun.args.forEach((v)-> newvars.put(v.name, it.next().welcome(this)));
		vars = newvars;
		
		
		return fun.body.welcome(this);
	}

	@Override
	public Integer visit(ConDef conDef) {
		// TODO Auto-generated method stub
		return null;
	}

	@Override
	public Integer visit(Param param) {
		// TODO Auto-generated method stub
		return null;
	}

	@Override
	public Integer visit(FieldSelect fieldSelect) {
		// TODO Auto-generated method stub
		return null;
	}

}
