package v6.name.panitz.wip;

import java.util.List;


public abstract class Tree {
	String type=null;
	int line;
	int column;
	
	public static class FieldSelect extends Tree {
		Tree o;
		String field;
		int nr=0;
		public FieldSelect(Tree o, String field) {
			super();
			this.o = o;
			this.field = field;
		}

		@Override
		<R> R welcome(Visitor<R> v) {
			return v.visit(this);
		}

		@Override
		int eval() {
			// TODO Auto-generated method stub
			return 0;
		}

	}

	public static class Param {
		String name;
		String typ;
		public Param(String name, String typ) {
			super();
			this.name = name;
			this.typ = typ;
		}
		String getJBCType() {
			return typ.equals("int")?"I":("L"+typ+";");
		}

	}

	public static class ConDef extends Tree{
		String name;
		List<Param> args;
		public ConDef(String image, List<Param> args) {
			super();
			this.name = image;
			this.args = args;
		}
		@Override
		<R> R welcome(Visitor<R> v) {
			return v.visit(this);
		}
		@Override
		int eval() {
			// TODO Auto-generated method stub
			return 0;
		}

	}

	public static class FunCall extends Tree {

		String name;
		List<Tree> params;

		public FunCall(String image, List<Tree> params) {
			this.name = image;
			this.params = params;
		}

		@Override
		<R> R welcome(Visitor<R> v) {
			return v.visit(this);
		}

		@Override
		int eval() {
			// TODO Auto-generated method stub
			return 0;
		}

	}

	public static class Variable extends Tree {

		String name;

		public Variable(String name) {
			this.name=name;
		}	

		@Override
		<R> R welcome(Visitor<R> v) {
			return v.visit(this);
		}

		@Override
		int eval() {
			// TODO Auto-generated method stub
			return 0;
		}

	}

	public static class Program extends Tree{
		List<ConDef> cons;
		List<FunDef> funs;
		Tree main;

		public Program(List<ConDef> cons, List<FunDef> funs, Tree t1) {
			this.cons = cons;
			this.funs = funs;
			this.main = t1;
		}

		@Override
		<R> R welcome(Visitor<R> v) {
			return v.visit(this);
		}

		@Override
		int eval() {
			// TODO Auto-generated method stub
			return 0;
		}

	}
	static enum Operator{
		mult,add;
	}
	

	abstract <R> R welcome(Visitor<R> v );
	
	abstract int eval();
	
	
	int eval1() {
		if (this instanceof IntLiteral) {
			var il = (IntLiteral)this;
			return il.n;
		}
		if (this instanceof OpExpr) {
			var oe = (OpExpr)this;
			return oe.lhs.eval1()*oe.rhs.eval1();
		}
		throw new RuntimeException();
	}
	
	static class FunDef extends Tree{
		String name;
		List<Param> args;
		Tree body;
		
		public FunDef(String name, List<Param> args, Tree body, String type) {
			super();
			this.name = name;
			this.args = args;
			this.body = body;
			this.type = type;
		}

		@Override
		<R> R welcome(Visitor<R> v) {
			return v.visit(this);
		}

		@Override
		int eval() {
			// TODO Auto-generated method stub
			return 0;
		}
		
	}
	
	static class OpExpr extends Tree{
		Tree lhs;
		Operator op;
		Tree rhs;
		public OpExpr(Tree lhs, Operator op, Tree rhs) {
			super();
			this.lhs = lhs;
			this.op = op;
			this.rhs = rhs;
		}
		@Override
		public String toString() {
			return "OpExpr [lhs=" + lhs + ", op=" + op + ", rhs=" + rhs + "]";
		}
		@Override
		int eval() {
			return lhs.eval()*rhs.eval();
		}
		@Override
		<R> R welcome(Visitor<R> v) {
			return v.visit(this);
		}
		
	}
	static class IntLiteral extends Tree{
		int n;
		public IntLiteral(int n) {
			super();
			this.n = n;
		}
		@Override
		public String toString() {
			return "IntLiteral [n=" + n + "]";
		}
		@Override
		int eval() {
			return n;
		}
		@Override
		<R> R welcome(Visitor<R> v) {
			return v.visit(this);
		}
		
	}
}
